%{
#undef YY_INPUT
#define YY_INPUT(buf, result, max_size) (result = slab_yyinput(buf, max_size))
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include <string.h>
#include <readline/readline.h>
#include "slab.h"
#include "y.tab.h"
#include "read_line.h"
#define ALLOC_SIZE (256)
static int
slab_yyinput(char *buf, int max_size);
int _return_type = 0;
static int __prompt = 0;
extern void add_history(char *string);
%}
%x     HELP
%start COMMENT
%start VALIDATION
%start VCOMMENT
%%

<INITIAL>"function"	return DEFINE;
<INITIAL>"for"	        return FOR;
<INITIAL>"if"		return IF;
<INITIAL>"else"		return ELSE;
<INITIAL>"while"	return WHILE;
<INITIAL>"do"   	return DO;
<INITIAL>"fft"   	return FFT;
<INITIAL>"ifft"   	return IFFT;
<INITIAL>"int"	        return INTERVAL;
<INITIAL>"ones"	        return ONES;
<INITIAL>"zeros"        return ZEROS;
<INITIAL>"eye"          return EYE;
<INITIAL>"real"         return REAL;
<INITIAL>"imag"         return IMAG;
<INITIAL>"upper"        return UPPER;
<INITIAL>"lower"        return LOWER;
<INITIAL>"max"          return MAX;
<INITIAL>"rand"         return RAND;
<INITIAL>"linspace"     return LINSPACE;
<INITIAL>"lread"        return LREAD;
<INITIAL>"linpro"       return LINPRO;
<INITIAL>"inv"          return INV;
<INITIAL>"norm"         return NORM;
<INITIAL>"print"        return PRINT;
<INITIAL>"tic"          return TIC;
<INITIAL>"toc"          return TOC;
<INITIAL>"plot"         return PLOT;
<INITIAL>"plot2"        return PLOT2;
<INITIAL>"plot3"        return PLOT3;
<INITIAL>"who"          return WHO;
<INITIAL>"save"         return SAVE;
<INITIAL>"eig"          return EIG;
<INITIAL>"tri"          return TRI;
<INITIAL>"schur"        return SCHUR;
<INITIAL>"lu"           return LU;
<INITIAL>"qr"           return QR;
<INITIAL>"chol"         return CHOL;
<INITIAL>"svd"          return SVD;
<INITIAL>"dif"          return DIF;
<INITIAL>"size"         return SIZE;
<INITIAL>"split"        return SPLIT;
<INITIAL>"con"          return CON;
<INITIAL>"name"         return NAME;
<INITIAL>"eval"         return EVAL;
<INITIAL>"'"            return TRANSPOSE;
<INITIAL>"("		return LP;
<INITIAL>")"		return RP;
<INITIAL>"{"	{
    ++_return_type; 
    return LC;
}
<INITIAL>"}"	{
    --_return_type;
    if(_return_type < 0)
    {
        _return_type = 0;
    }
    return RC;
}
<INITIAL>"["		return LB;
<INITIAL>"]"		return RB;
<INITIAL>"|"		return SEPARATOR;
<INITIAL>"||"		return OR;
<INITIAL>"&&"		return AND;
<INITIAL>";"		return SEMICOLON;
<INITIAL>","		return COMMA;
<INITIAL>"."		return PIRIOD;
<INITIAL>"="		return ASSIGN;
<INITIAL>"=="		return EQ;
<INITIAL>"!="		return NE;
<INITIAL>">"		return GT;
<INITIAL>">="		return GE;
<INITIAL>"<"		return LT;
<INITIAL>"<="		return LE;
<INITIAL>"+"		return ADD;
<INITIAL>"-"		return SUB;
<INITIAL>"*"		return MUL;
<INITIAL>"/"		return DIV;
<INITIAL>"\\"		return SOLVE;
<INITIAL>"%"		return MOD;
<INITIAL>"exit"         return EXIT;
<INITIAL>"sin"          return SIN;
<INITIAL>"^"            return POW;
<INITIAL>"cos"          return COS;
<INITIAL>"log"          return LOG;
<INITIAL>"log10"        return LOGTEN;
<INITIAL>"ln"           return LOG;
<INITIAL>"exp"          return EXP;
<INITIAL>"fabs"         return FABS;
<INITIAL>"abs"          return FABS;
<INITIAL>"tan"          return TAN;
<INITIAL>"atan"         return ATAN;
<INITIAL>"acos"         return ACOS;
<INITIAL>"asin"         return ASIN;
<INITIAL>"cosh"         return COSH;
<INITIAL>"sinh"         return SINH;
<INITIAL>"tanh"         return TANH;
<INITIAL>"sqrt"         return SQRT;
<INITIAL>"up"           return UP;
<INITIAL>"down"         return DOWN;
<INITIAL>"near"         return NEAR;
<INITIAL>"getbits"      return GETBITS;
<INITIAL>"sfile"        return SFILE;
<INITIAL>"read"         return SFILE;
<INITIAL>"M_PI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_PI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_E" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_E;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_LOG2E" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LOG2E;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_LOG10E" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LOG10E;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_LN2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LN2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_LN10" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LN10;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_PI_2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_PI_2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_PI_4" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_PI_4;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_1_PI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_1_PI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_2_PI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_2_PI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_2_SQRTPI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_2_SQRTPI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_SQRT2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_SQRT2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"M_SQRT1_2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_SQRT1_2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>"verification" {
    __prompt = 1;
    BEGIN VALIDATION;
}
<INITIAL>^"help"  {
    __prompt = 2;
    BEGIN HELP;
    return HELP_INIT;
}
<INITIAL>"\n"  {
    if(_return_type == 0)
    {
         return RETURN1;
    }
}
<INITIAL>[A-Za-z_][A-Za-z_0-9]* {
    yylval.identifier = clc_malloc(strlen(yytext) + 1);
    strcpy(yylval.identifier, yytext);
    return IDENTIFIER;
}
<INITIAL>[A-Za-z_][A-Za-z_0-9]*\."s" {
    yylval.identifier = clc_malloc(strlen(yytext) + 1);
    strcpy(yylval.file_identifier, yytext);
    return FILE_IDENTIFIER;
}
<INITIAL>[A-Za-z_][A-Za-z_0-9]*\."dat" {
    yylval.identifier = clc_malloc(strlen(yytext) + 1);
    strcpy(yylval.data_file, yytext);
    return DATA_FILE;
}
<INITIAL>[1-9][0-9]* {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    sscanf(yytext, "%lf", &expression->u.double_value);
    yylval.expression = expression;
    return INT_LITERAL;
}
<INITIAL>"0" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = 0;
    yylval.expression = expression;
    return INT_LITERAL;
}
<INITIAL>[0-9]*\.[0-9]* {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    sscanf(yytext, "%lf", &expression->u.double_value);
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<INITIAL>[ \t] ;
<INITIAL>^!	{
    __prompt = 1;
    BEGIN VALIDATION;
}
<INITIAL>^#	BEGIN COMMENT;
<INITIAL>.	clc_compile_error(CHARACTER_INVALID_ERR, NULL);
<COMMENT>\n	BEGIN INITIAL;
<COMMENT>.      ;
<HELP>^"help"              return HELP_INIT;
<HELP>[A-Za-z_][A-Za-z_0-9\\]* {
    yylval.identifier = clc_malloc(strlen(yytext) + 1);
    strcpy(yylval.help_identifier, yytext);
    return HELP_IDENTIFIER;
}
<HELP>"$"            {
    __prompt = 0;
    BEGIN INITIAL;
}
<VALIDATION>"function"	   return DEFINE;
<VALIDATION>"for"	   return FOR;
<VALIDATION>"if"           return IF;
<VALIDATION>"else"	   return ELSE;
<VALIDATION>"while"        return WHILE;
<VALIDATION>"do"           return DO;
<VALIDATION>"fft"          return FFT;
<VALIDATION>"ifft"         return IFFT;
<VALIDATION>"int"          return INTERVAL;
<VALIDATION>"eye"          return EYE;
<VALIDATION>"ones"         return ONES;
<VALIDATION>"zeros"        return ZEROS;
<VALIDATION>"rand"         return RAND;
<VALIDATION>"linspace"     return LINSPACE;
<VALIDATION>"linpro"       return LINPRO;
<VALIDATION>"lread"        return LREAD;
<VALIDATION>"inv"          return INV;
<VALIDATION>"real"         return REAL;
<VALIDATION>"imag"         return IMAG;
<VALIDATION>"upper"        return UPPER;
<VALIDATION>"lower"        return LOWER;
<VALIDATION>"max"          return MAX;
<VALIDATION>"eig"          return VEIG;
<VALIDATION>"tri"          return TRI;
<VALIDATION>"schur"        return SCHUR;
<VALIDATION>"lu"           return LU;
<VALIDATION>"qr"           return QR;
<VALIDATION>"chol"         return CHOL;
<VALIDATION>"svd"          return SVD;
<VALIDATION>"dif"          return DIF;
<VALIDATION>"split"        return SPLIT;
<VALIDATION>"size"         return SIZE;
<VALIDATION>"con"          return CON;
<VALIDATION>"name"         return NAME;
<VALIDATION>"eval"         return EVAL;
<VALIDATION>"norm"         return NORM;
<VALIDATION>"print"        return PRINT;
<VALIDATION>"who"          return WHO;
<VALIDATION>"save"         return SAVE;
<VALIDATION>"tic"          return TIC;
<VALIDATION>"toc"          return TOC;
<VALIDATION>"plot"         return PLOT;
<VALIDATION>"plot2"        return PLOT2;
<VALIDATION>"plot3"        return PLOT3;
<VALIDATION>"("		   return LP;
<VALIDATION>")"		   return RP;
<VALIDATION>"{"	{
    ++_return_type; 
    return LC;
}
<VALIDATION>"}"	{
    --_return_type;
    if(_return_type < 0)
    {
        _return_type = 0;
    }
    return RC;
}
<VALIDATION>"["		   return LB;
<VALIDATION>"]"		   return RB;
<VALIDATION>"|"		   return SEPARATOR;
<VALIDATION>"||"           return OR;
<VALIDATION>"&&"           return AND;
<VALIDATION>";"		   return SEMICOLON;
<VALIDATION>","            return COMMA;
<VALIDATION>"."            return PIRIOD;
<VALIDATION>"="	           return ASSIGN;
<VALIDATION>"=="           return EQ;
<VALIDATION>"!="           return NE;
<VALIDATION>">"		   return GT;
<VALIDATION>">="           return GE;
<VALIDATION>"<"		   return LT;
<VALIDATION>"<="           return LE;
<VALIDATION>"+"		   return ADD;
<VALIDATION>"-"		   return SUB;
<VALIDATION>"*"		   return MUL;
<VALIDATION>"/"		   return DIV;
<VALIDATION>"\\"	   return EXACTSOLVE;
<VALIDATION>"%"		   return MOD;
<VALIDATION>"exit"         return EXIT;
<VALIDATION>"sin"          return VSIN;
<VALIDATION>"^"            return POW;
<VALIDATION>"cos"          return VCOS;
<VALIDATION>"log"          return VLOG;
<VALIDATION>"log10"        return LOGTEN;
<VALIDATION>"ln"           return VLOG;
<VALIDATION>"exp"          return VEXP;
<VALIDATION>"fabs"         return FABS;
<VALIDATION>"abs"          return FABS;
<VALIDATION>"tan"          return VTAN;
<VALIDATION>"atan"         return ATAN;
<VALIDATION>"acos"         return ACOS;
<VALIDATION>"asin"         return ASIN;
<VALIDATION>"cosh"         return COSH;
<VALIDATION>"sinh"         return SINH;
<VALIDATION>"tanh"         return TANH;
<VALIDATION>"sqrt"         return SQRT;
<VALIDATION>"up"           return UP;
<VALIDATION>"down"         return DOWN;
<VALIDATION>"near"         return NEAR;
<VALIDATION>"getbits"      return GETBITS;
<VALIDATION>"sfile"        return SFILE;
<VALIDATION>"read"         return SFILE;
<VALIDATION>"M_PI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_PI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_E" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_E;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_LOG2E" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LOG2E;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_LOG10E" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LOG10E;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_LN2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LN2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_LN10" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_LN10;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_PI_2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_PI_2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_PI_4" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_PI_4;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_1_PI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_1_PI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_2_PI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_2_PI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_2_SQRTPI" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_2_SQRTPI;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_SQRT2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_SQRT2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"M_SQRT1_2" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = M_SQRT1_2;
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>"approximation" {
    __prompt = 0;
    BEGIN INITIAL;
}
<VALIDATION>^"help"  {
    __prompt = 2;
    BEGIN HELP;
    return HELP_INIT;
}
<VALIDATION>"$"            {
    __prompt = 0;
    BEGIN INITIAL;
}
<VALIDATION>"\n"  {
    if(_return_type == 0)
    {
         return RETURN1;
    }
}
<VALIDATION>[A-Za-z_][A-Za-z_0-9]* {
    yylval.identifier = clc_malloc(strlen(yytext) + 1);
    strcpy(yylval.identifier, yytext);
    return IDENTIFIER;
}
<VALIDATION>[A-Za-z_][A-Za-z_0-9]*\."s" {
    yylval.identifier = clc_malloc(strlen(yytext) + 1);
    strcpy(yylval.file_identifier, yytext);
    return FILE_IDENTIFIER;
}
<VALIDATION>[A-Za-z_][A-Za-z_0-9]*\."dat" {
    yylval.identifier = clc_malloc(strlen(yytext) + 1);
    strcpy(yylval.data_file, yytext);
    return DATA_FILE;
}
<VALIDATION>[1-9][0-9]* {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    sscanf(yytext, "%lf", &expression->u.double_value);
    yylval.expression = expression;
    return INT_LITERAL;
}
<VALIDATION>"0" {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    expression->u.double_value = 0;
    yylval.expression = expression;
    return INT_LITERAL;
}
<VALIDATION>[0-9]*\.[0-9]* {
    Expression	*expression = clc_alloc_expression(DOUBLE_EXPRESSION);
    sscanf(yytext, "%lf", &expression->u.double_value);
    yylval.expression = expression;
    return DOUBLE_LITERAL;
}
<VALIDATION>[ \t] ;
<VALIDATION>^#	BEGIN VCOMMENT;
<VALIDATION>.	clc_compile_error(CHARACTER_INVALID_ERR, NULL);
<VCOMMENT>\n	BEGIN VALIDATION;
<VCOMMENT>.      ;
%%
static char *st_readline_buffer = 0;
static int  st_readline_used_len;
static char *st_line_buffer = NULL;
static int st_current_buffer_size = 0;
static int st_current_used_size = 0;

void
clc_initialize_readline_buffer(void)
{
    if (st_readline_buffer) {
	free(st_readline_buffer);
    }
    st_readline_buffer = NULL;
    st_readline_used_len = 0;
}

static int
tty_input(char *buf, int max_size)
{
    int	len;
    FILE *fp;

    if (st_readline_buffer !=0) {
        free(st_readline_buffer);
        st_readline_buffer = 0;
    }
    if (st_readline_buffer == NULL) {
	st_readline_used_len = 0;
        if(__prompt == 0) {
	    st_readline_buffer = readline("A> ");
        } else if(__prompt == 1) {
	    st_readline_buffer = readline("V> ");
        } else if(__prompt == 2) {
	    st_readline_buffer = readline("H> ");
        }

	if (st_readline_buffer == NULL) {
	    return 0;
	}
        if(st_readline_buffer && *st_readline_buffer) {
            add_history(st_readline_buffer);
        }
        len = strlen(st_readline_buffer);
        st_readline_buffer = realloc(st_readline_buffer, sizeof(char)*(len+2));
        st_readline_buffer[len] = '\n';
        st_readline_buffer[len+1] = '\0';
        fp = fopen("_temp", "w");
        if(fp != NULL)
        {
            fprintf(fp,"%s",st_readline_buffer); 
            fclose(fp);
        }
        system("cat _temp2 _temp > _history");
        system("cp _history _temp2");
    }
    len = smaller(strlen(st_readline_buffer) - st_readline_used_len,
		  max_size);
    strncpy(buf, &st_readline_buffer[st_readline_used_len], len);

    st_readline_used_len += len;

    if (st_readline_buffer[st_readline_used_len] == '\0') {
	free(st_readline_buffer);
	st_readline_buffer = NULL;
    }
    
    return len;
}

static int
file_input(char *buf, int max_size)
{
    int	len;

    if (st_readline_buffer == NULL) {
	st_readline_used_len = 0;
	st_readline_buffer = read_line(clc_current_interpreter->input_fp);

	if (st_readline_buffer == NULL) {
	    return 0;
	}
    }
    len = smaller(strlen(st_readline_buffer) - st_readline_used_len,
		  max_size);
    strncpy(buf, &st_readline_buffer[st_readline_used_len], len);

    st_readline_used_len += len;

    if (st_readline_buffer[st_readline_used_len] == '\0') {
	free(st_readline_buffer);
	st_readline_buffer = NULL;
    }
    free(st_readline_buffer);
    return len;
}

static int
slab_yyinput(char *buf, int max_size)
{
    int	result;

    switch (clc_current_interpreter->input_mode) {
      case SLAB_TTY_INPUT_MODE:
	result = tty_input(buf, max_size);
	break;
      case SLAB_FILE_INPUT_MODE:
	result = file_input(buf, max_size);
	break;
    }
    return result;
}

static void
add_character(int ch)
{
    assert(st_current_buffer_size >= st_current_used_size);

    if (st_current_buffer_size == st_current_buffer_size) {
        st_line_buffer  = realloc(st_line_buffer,
                     (st_current_buffer_size + ALLOC_SIZE) * sizeof(char));
        st_current_buffer_size += ALLOC_SIZE;
    }

    st_line_buffer[st_current_used_size] = ch;
    st_current_used_size++;
}

void free_buffer(void)
{
    free(st_line_buffer);
    st_line_buffer = NULL;
    st_current_buffer_size = 0;
    st_current_used_size = 0;
}

char *read_line(FILE *fp)
{
    int    ch;
    char   *ret;

    st_current_used_size = 0;
    while ((ch = getc(fp)) != EOF) {
        if (ch == '\n') {
            add_character('\n');
            add_character('\0');
            break;
        }
        add_character(ch);
    }
    if (ch == EOF) {
        if (st_current_used_size > 0) {
            add_character('\n');
            add_character('\0');
        } else {
            return NULL;
        }
    }

    ret = malloc(sizeof(char) * st_current_used_size);
    strcpy(ret, st_line_buffer);

    return ret;
}



